#!/bin/sh

echo COPY CONFIG_DIR=$CONFIG_DIR NODE=$NODE HOST=$HOST PORT=$PORT TESTRUN=$TESTRUN PREVTESTRUN=$PREVTESTRUN 
echo "##############################"
. $CONFIG_DIR/clusters/$CLUSTER/cluster.conf

TESTRUN_DIR=$TESTRUNS_DIR/$TESTRUN
COPY_TEST_DIR=$TESTRUN_DIR/$TESTNAME

mkdir -p $COPY_TEST_DIR

if [ -n $PREVTESTRUN -a $PREVTESTRUN != "--" ]
then
    CHP=$TESTRUNS_DIR/$PREVTESTRUN/$CHECK_POINT
    echo -n "Copying a check point..."
    if [ -f $CHP ]
    then
        cp -vf $CHP $COPY_TEST_DIR
        echo "[OK]"
    else
        echo "[FAIL]: not found"
    fi
fi

echo -n "Archiving test files... "
cp -rf $CONFIG_DIR/tests/$TESTNAME/* $COPY_TEST_DIR 
LAST_DIR=`pwd`;
cd $COPY_TEST_DIR
    tar --dereference -czf ../$TESTNAME.tgz *
cd $LAST_DIR
echo "[OK]" 

rm -rvf $COPY_TEST_DIR 

echo "Transfering test files... " 
ssh -o GSSAPIAuthentication=no -f $USER@$HOST "mkdir -p ${NODE_WORK}"
scp -o GSSAPIAuthentication=no -r $TESTRUN_DIR/$TESTNAME.tgz $USER@$HOST:${NODE_WORK}
ssh -o GSSAPIAuthentication=no -f $USER@$HOST "cd ${NODE_WORK}; tar xzf $TESTNAME.tgz; rm -f $TESTNAME.tgz"
echo "Transfering test files... [OK]"

rm -f $TESTRUN_DIR/$TESTNAME.tgz

echo COPY END
